<h1 align="center">Rusty Book( 锈书 )</h1>

<div align="center">
    <img src="https://github.com/studyrs/rusty-book/blob/main/assets/banner.gif?raw=true" />
</div>
   
<div align="center">

    
在线阅读: https://rusty.course.rs
</div>

在 Rust 元宇宙，夸奖别人的最高境界就是 `rusty`: 今天你"锈"了吗? 你的 Rust 代码好锈啊！而本书，就是精选了各种开源库和代码片段，帮助大家打造优"锈"的 Rust 项目。

总之，如果有以下需求，那看锈书就对了：

- 想要知道现在优秀的、关注度高的 Rust 项目有哪些

- 发现一些好玩、有趣、酷炫的开源库

- 需要寻找某个类型的库，例如，一个 HTTP 客户端或 ProtoBuffer 编码库，要求是好用、更新活跃、高质量

- 想要寻找常用操作的代码片段，用于熟悉 Rust 或者直接复制粘贴到自己的项目中，例如文件操作、数据库操作、HTTP 请求、排序算法、正则等


细心的同学可能会发现，1-3 对应的是 [awesome-rust](https://github.com/rust-unofficial/awesome-rust), 4 对应的是 [rust-cookbook](https://github.com/rust-lang-nursery/rust-cookbook)，那么锈书除了整合两块内容，合二为一外，还有其它的优点吗？

## 它们存在的问题

**awesome-rust，最大的问题就是里面的内容鱼龙混**。低质量的、几年不更新的、分类不准的比比皆是，而且缺乏对项目的详细分析介绍，更多的就是把所有东西给你列出来，告诉你：诺，这几十个都是你想要的，自己挑吧。至于为什么会这样，根源在于它允许任何人去提交自己的库的链接，几乎没有做任何筛选。

所以，个人觉得不应该叫 awesome-rust，叫 all-rust 更为合适。如果存在疑义的同学，可以自己调研一番，再跟锈书的项目对比下，就明白我所言是否有虚了。


对于开发者而言，Cookbook 非常实用，几乎每一门编程语言都是如此。原因无他：聪明的开发者大部分时间不是在复制粘贴就是在复制粘贴的路上。而 CookBook 恰恰为各种实用场景提供了可供直接复制粘贴的代码，例如网络协议、数据库和文件操作、随机数生成、命令行解析等。

**但目前的 Rust Cookbook 更新非常不活跃，里面缺少了大量实用库，还有一些过时的老库**。

哦对了，还有一点，它们都不是中文的，而锈书是基于中文写的，很快还将翻译成英文。

## 我们的优势

既然列出了别人的缺点，那我们自然是为了解决这些问题而来的。总的来说，锈书有以下特点：

- 分类更加清晰、实用，也更方便于用户找到想要的库

- 所有的库都是精选的，就算通过 PR 提交的，也必须经过我们的严格审核后，再能加入

- 长期不更新的库( 一些已经稳定的工具库除外 )要坚决的移除

- 每一个库都有较为详细的介绍甚至是配图，让大家争取不用进到项目里调查一番，就知道该项目的详细用途

## 社区贡献

欢迎大家提交任何类型的 PR：好的库、实用的代码片段、内容和文字勘误等等，一切的一切对我们来说都特别宝贵，对于贡献高的用户，我们还将在未来送上神秘礼物和惊喜。





