# 游戏
我们精心挑选了一些用Rust写得优秀游戏，希望大家喜欢：)

### 目录索引
| 游戏名   | 描述   | 
| ------ | ----- |
| [veloren](#veloren) | 多人在线3D PRG游戏 | 
| [citybound](#citybound) | 多人在线城市模拟游戏 |
| [sandspiel](#sandspiel) | 创意游戏-落沙世界 |  
| [fish fight](#fish-fight) | 多人2D射击策略游戏 | 
| [doukutsu](#doukutsu) | `Cave Story`重制版 |
| [rusted ruins](#rusted-ruins) | 开发世界、像素游戏 |
| [sulis](#sulis) | 回合制策略游戏 | 
| [zemeroth](#zemeroth) | 2D棋盘策略游戏 | 
| [mk48](#mk48) | 2D多人在线海战游戏 | 
| [theta wave](#theta-wave) | 2D太空射击游戏 | 
| [rust doom](#rust-doom) | 模仿`Doom`的射击游戏 | 

### veloren
[Veloren](https://gitlab.com/veloren/veloren)是一款多人在线3D RPG游戏，该游戏借鉴了`Cube World`、`Minecraft(我的世界)`和`Dwarf fortress`。

目前游戏开发非常活跃，也是Rust目前游戏中最有前景的之一，值得看好，当前已经可以玩，你可以通过[官方地址](https://veloren.net/account/)在线试玩。

<img alt="veloren screenshot" width="100%" src="https://github.com/studyrs/cookbook-images/blob/main/game/veloren.jpg?raw=true" class="center"  />

### citybound
[citybound](https://github.com/citybound/citybound)是一个多人在线模拟游戏，使用Rust + WASM + JS开发。

<img alt="citybound screenshot" width="100%" src="https://github.com/studyrs/cookbook-images/blob/main/game/citybound.png?raw=true" class="center"  />

### sandspiel
[sandspiel](https://github.com/MaxBittker/sandspiel)是一款很有创意、很艺术的游戏，通过天上落下的沙子来构建美丽的沙世界。该游戏使用Rust + wasm + webgl + js(胶水，用来粘合前几个)构建。

你可以[在线试玩](https://sandspiel.club)，尝试构建自己的沙世界。

<img alt="sandspiel screenshot" width="100%" src="https://github.com/studyrs/cookbook-images/blob/main/game/sandspiel.png?raw=true" class="center"  />

### fish-fight
[Fish Fight](https://github.com/fishfight/FishFight)是一款2D射击策略游戏，支持最多4人一起玩，可以通过在线的方式或共享屏幕的方式玩，总之这是一款相当不错的游戏，[官网](https://fishfight.org)做得也很酷。

<img alt="fish-fight screenshot" width="100%" src="https://github.com/studyrs/cookbook-images/blob/main/game/fish-fight.jpg?raw=true" class="center"  />

### doukutsu
[doukutsu](https://github.com/doukutsu-rs/doukutsu-rs)是2004年发行的视频游戏`Cave Story`的重制版，使用Rust开发。

<img alt="doukutsu1 screenshot" width="100%" src="https://github.com/studyrs/cookbook-images/blob/main/game/doukutsu1.
png?raw=true" class="center"  />
<img alt="doukutsu2 screenshot" width="100%" src="https://github.com/studyrs/cookbook-images/blob/main/game/doukutsu2.
png?raw=true" class="center"  />

### rusted-ruins
[rusted-ruins](https://github.com/garkimasera/rusted-ruins)是一个开放世界2D像素游戏，用户可以在里面探索各种野外和废墟。

目前游戏还处于较为早期阶段，但是开发活跃。

<img alt="rusted-ruins1 screenshot" width="100%" src="https://github.com/studyrs/cookbook-images/blob/main/game/rusted-ruins1.
png?raw=true" class="center"  />
<img alt="rusted-ruins2 screenshot" width="100%" src="https://github.com/studyrs/cookbook-images/blob/main/game/rusted-ruins2.
png?raw=true" class="center"  />

### sulis
[sulis](https://github.com/Grokmoo/sulis)是一款回合制策略游戏，包含了一个从零开发的引擎，目前游戏已经具备相当高的可玩性，你还可以选择不同的势力，感兴趣的同学可以一试。

<img alt="sulis screenshot" width="100%" src="https://github.com/studyrs/cookbook-images/blob/main/game/sulis.jpg?raw=true" class="center"  />

### zemeroth
[zemeroth](https://github.com/ozkriff/zemeroth)是一个2D棋盘策略游戏，通过Rust + WASM实现。

你可以通过[在线网址](https://ozkriff.itch.io/zemeroth)，使用WASM来体验这个游戏。

<img alt="zemeroth1 screenshot" width="100%" src="https://github.com/studyrs/cookbook-images/blob/main/game/zemeroth1.
png?raw=true" class="center"  />
<img alt="zemeroth2 screenshot" width="100%" src="https://github.com/studyrs/cookbook-images/blob/main/game/zemeroth2.
jpeg?raw=true" class="center"  />

### mk48
[mk48](https://github.com/SoftbearStudios/mk48)是一个2D海战游戏，支持多人在线和和多语言(包括中文)，你可以通过官方网址在线试玩: [https://mk48.io](https://mk48.io)。

<img alt="mk48 screenshot" width="100%" src="https://github.com/studyrs/cookbook-images/blob/main/game/mk48.
jpg?raw=true" class="center"  />

### theta wave
[Theta Wave](https://github.com/thetawavegame/thetawave-legacy)是一款2D太空射击游戏，基于`Amethyst`引擎开发。

在游戏中，你扮演的是保卫目标的飞船，游戏的目标是通过摧毁敌人来存活，还可以收集货币用于购买对你的生存有帮助的物品，并击败最终BOSS取得胜利。

<img alt="theta-wave screenshot" width="100%" src="https://github.com/studyrs/cookbook-images/blob/main/game/theta.
jpg?raw=true" class="center"  />


### rust doom
[Rust doom](https://github.com/cristicbz/rust-doom)是一款模仿`Doom 1&2`的简单射击游戏，需要注意，它并不是一个`Doom`移植版。

<img alt="rust-doom screenshot" width="100%" src="https://github.com/studyrs/cookbook-images/blob/main/game/rust-doom.
jpg?raw=true" class="center"  />